import ChainHash.Node;

// `FC@ɂnbV

public class ChainHash<K,V> {

	//--- nbV\m[h ---//
	class Node<K,V> {
		private K key;						// L[l
		private V data;						// f[^
		private Node<K,V> next;		// 㑱|C^i㑱m[hւ̎QƁj

		//--- RXgN^ ---//
		Node(K key, V data, Node<K,V> next) {
			this.key  = key;
			this.data = data;
			this.next = next;
		}

		//--- L[lԂ ---//
		K getKey() {
			return key;
		}

		//--- f[^Ԃ ---//
		V getValue() {
			return data;
		}

		//--- L[̃nbVlԂ ---//
		public int hashCode() {
			return key.hashCode();
		}
	}

	private int	size;							// nbV\̑傫
	private Node<K,V>[] table;		// nbV\

	//--- RXgN^ ---//
	public ChainHash(int capacity) {
		try {
			table = new Node[capacity];
			this.size = capacity;
		} catch (OutOfMemoryError e) {		// \𐶐łȂ
			this.size = 0;
		}
	}

	//--- nbVl߂ ---//
	public int hashValue(Object key) {
		return key.hashCode() % size;
	}

	//--- L[lkey̗vf̒Tif[^ԋpj ---//
	public V search(K key) {
		int hash = hashValue(key);			// Tf[^̃nbVl
		Node<K,V> p = table[hash];			// ڃm[h

		while (p != null) {
			if (p.getKey().equals(key))
				return p.getValue();				// T
			p = p.next;										// 㑱m[hɒ
		}
		return null;										// Ts
	}

	//--- L[lkeyŃf[^data̗vf̒ǉ ---//
	public int add(K key, V data) {
		int hash = hashValue(key);			// ǉf[^̃nbVl
		Node<K,V> p = table[hash];			// ڃm[h

		while (p != null) {
			if (p.getKey().equals(key))		// ̃L[l͓o^
				return 1;
			p = p.next;										// 㑱m[hɒ
		}
		Node<K,V> temp = new Node<K,V>(key, data, table[hash]);
		table[hash] = temp;							// m[h}
		return 0;
	}

	//--- L[lkey̗vf̍폜 ---//
	public int remove(K key) {
		int hash = hashValue(key);			// 폜f[^̃nbVl
		Node<K,V> p = table[hash];			// ڃm[h
		Node<K,V> pp = null;						// O̒ڃm[h

		while (p != null) {
			if (p.getKey().equals(key)) {	// 
				if (pp == null)
					table[hash] = p.next;
				else
					pp.next = p.next;
				return 0;
			}
			pp = p;
			p = p.next;										// 㑱m[hɒ
		}
		return 1;												// ̃L[l݂͑Ȃ
	}

	//--- nbV\_v ---//
	public void dump() {
		for (int i = 0; i < size; i++) {
			Node<K,V> p = table[i];
			System.out.printf("%02d  ", i);
			while (p != null) {
				System.out.printf(" %s (%s)  ", p.getKey(), p.getValue());
				p = p.next;
			}
			System.out.println();
		}
	}
}
