// K4-3
// int^Œ蒷X^bN

public class DoubleHeadIntStack {
	private int[] stk;		// X^bN̖{
	private int capacity;	// X^bN̗eʁi`Ea̍vj
	private int ptrA;			// X^bN|C^`
	private int ptrB;			// X^bN|C^a

	public enum AorB {StackA, StackB};

	//--- sOFX^bN ---//
	public class EmptyDoubleHeadIntStackException extends RuntimeException {
		public EmptyDoubleHeadIntStackException() { }
	}

	//--- sOFX^bNt ---//
	public class OverflowDoubleHeadIntStackException extends RuntimeException {
		public OverflowDoubleHeadIntStackException() { }
	}

	//--- RXgN^ ---//
	public DoubleHeadIntStack(int maxlen) {
		ptrA = 0;
		ptrB = maxlen - 1;
		capacity  = maxlen;
		try {
			stk = new int[capacity];				// X^bN{̗p̔z𐶐
		} catch (OutOfMemoryError e) {		// łȂ
			capacity = 0;
		}
	}

	//--- X^bNxvbV ---//
	public int push(AorB sw, int x) throws OverflowDoubleHeadIntStackException {
		if (ptrA >= ptrB + 1)							// X^bN͖t
			throw new OverflowDoubleHeadIntStackException();
		switch (sw) {
		 case StackA: stk[ptrA++] = x; break;
		 case StackB: stk[ptrB--] = x; break;
		}
		return x;
	}

	//--- X^bNf[^|bvĩf[^oj ---//
	public int pop(AorB sw) throws EmptyDoubleHeadIntStackException {
		int x = 0;
		switch (sw) {
		 case StackA: 
			if (ptrA <= 0)									// X^bN`͋
				throw new EmptyDoubleHeadIntStackException();
			x = stk[--ptrA];
			break;
		 case StackB:
			if (ptrB >= capacity - 1)				// X^bNa͋
				throw new EmptyDoubleHeadIntStackException();
			x = stk[++ptrB];
			break;
		}
		return x;
	}

	//--- X^bNf[^s[Nĩf[^`j ---//
	public int peek(AorB sw) throws EmptyDoubleHeadIntStackException {
		int x = 0;
		switch (sw) {
		 case StackA: 
			if (ptrA <= 0)									// X^bN`͋
				throw new EmptyDoubleHeadIntStackException();
			x = stk[ptrA - 1];
			break;
		 case StackB:
			if (ptrB >= capacity - 1)				// X^bNa͋
				throw new EmptyDoubleHeadIntStackException();
			x = stk[ptrB + 1];
			break;
		}
		return x;
	}

	//--- X^bNxTăCfbNXiȂ-1jԂ ---//
	public int indexOf(AorB sw, int x) {
		switch (sw) {
		 case StackA: 
			for (int i = ptrA - 1; i >= 0; i--)				// 㑤`T
				if (stk[i] == x)
					return i;							// T
			break;
		 case StackB:
			for (int i = ptrB + 1; i < capacity; i++)	// 㑤`T
				if (stk[i] == x)
					return i;						// T
			break;
		}
		return -1;								// Ts
	}

	//--- X^bNɂ ---//
	public void clear(AorB sw) {
		switch (sw) {
		 case StackA: ptrA = 0; break;
		 case StackB: ptrB = capacity - 1; break;
		}
	}

	//--- X^bN̗eʂԂi`Ƃa̍vj---//
	public int getCapacity() {
		return capacity;
	}

	//--- X^bNɐς܂Ăf[^Ԃ ---//
	public int size(AorB sw) {
		switch (sw) {
		 case StackA: return ptrA;
		 case StackB: return capacity - ptrB - 1;
		}
		return 0;
	}

	//--- X^bN͋ł邩 ---//
	public boolean isEmpty(AorB sw) {
		switch (sw) {
		 case StackA: return ptrA <= 0;
		 case StackB: return ptrB >= capacity - 1;
		}
		return true;
	}

	//--- X^bN͖tł邩 ---//
	public boolean isFull() {
		return ptrA >= ptrB + 1;
	}

	//--- X^bN̑Sf[^ꁨ̏ɕ\ ---//
	public void dump(AorB sw) {
		switch (sw) {
		 case StackA:
			if (ptrA <= 0)
				System.out.println("X^bN͋łB");
			else {
				for (int i = 0; i < ptrA; i++)
					System.out.print(stk[i] + " ");
				System.out.println();
			}
			break;
		 case StackB:
			if (ptrB >= capacity - 1)
				System.out.println("X^bN͋łB");
			else {
				for (int i = capacity - 1; i > ptrB; i--)
					System.out.print(stk[i] + " ");
				System.out.println();
			}
			break;
		}
	}
}
